#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include <mex.h>

#include "../headers/matrix.h"
#include "../headers/kmeans.h"
#include "../headers/mexConversion.h"

/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/* It does not normalize the data. So, if you want to normalize the data,  */
/* do it before calling the kmeans function                                */
/* It works the 2D-data where the rows correspond to instances and the     */
/* columns correspond to the features                                      */
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[]){
    int k           = (int)(mxGetScalar(prhs[1]));
    MATRIXD data    = convertMxArray2MatrixD(prhs[0]);
    MATRIXD V       = kmeans(data,k,500);
    MATRIX cmap     = findClusterLabelsUsingEuclideanDistance(data,V);

    
    plhs[0]         = convertMatrix2MxArray(cmap);
    plhs[1]         = convertMatrixD2MxArray(V);
    
    freeMatrix(cmap);
    freeMatrixD(V);
    freeMatrixD(data);
}





